<template>
  <v-container fill-width fill-height>
    <v-row justify="center" class="align-self-start">
      <SectionTitle v-bind:title="'My Node'" class="col col-12" />
      <NodeInfo />
    </v-row>
    <v-row class="align-self-start mt-10" justify="center">
      <v-col cols="11" class="px-0">
        <div class="d-flex mx-4" v-if="!$store.getters['user/isOrgaAdmin']">
          <v-autocomplete
            style="max-width:28%;"
            dense
            clearable
            :items="organisations"
            v-model="selectedOrga"
            :search-input.sync="searchForOrga"
            return-object
            item-text="name"
            :loading="isOrgLoading"
            persistent-hint
            label="Select organisation"
            hint="Search for an organisation or filter by parent"
            append-icon="mdi-magnify"
            @change="
              options.page = 1;
              getUsers();
            "
          >
          </v-autocomplete>
          <v-select
            v-if="$store.getters['user/getUserTenants'].length > 1"
            dense
            label="Filter by constituency"
            class="ml-4"
            style="max-width: 22%;"
            :items="$store.getters['user/getUserTenants']"
            @change="
              options.page = 1;
              getUsers();
            "
            v-model="selectedTenant"
            return-object
            clearable
            small-chips
            item-text="name"
          ></v-select>
        </div>
        <Pagination
          @pagination-object="checkPaginationObject"
          v-bind:sortDirection="sortDirection"
          v-bind:totalItems="totalUser"
          type="users"
        />
      </v-col>
      <v-col cols="11">
        <v-card elevation="6" max-height="70vh" class="overflow-y-auto">
          <v-subheader class="text-h5">Users</v-subheader>
          <v-divider></v-divider>
          <v-data-table
            disable-pagination
            dense
            :server-items-length="totalUser"
            hide-default-footer
            :loading="loading"
            :items="users"
            item-key="id"
            :sort-desc.sync="sortDirection"
            :headers="[
              {
                text: 'Name',
                align: 'start',
                value: 'name',
                divider: true
              },
              { text: 'Email', value: 'email', divider: true, sortable: false },
              {
                text: 'Roles',
                value: 'roles',
                divider: true,
                sortable: false
              },
              { text: 'Nodes', value: 'nodes', divider: true, sortable: false },
              {
                text: 'Actions',
                value: 'actions',
                sortable: false,
                width: '90px'
              }
            ]"
          >
            <template v-slot:[`item.name`]="{ item }">
              {{ item.name === item.email ? "" : item.name }}
            </template>
            <template v-slot:[`item.nodes`]="{ item }">
              {{ formNodes(item.groups) }}
            </template>
            <template v-slot:[`item.roles`]="{ item }">
              <v-icon v-if="formRoles(item.groups).includes('portaladmin')"
                >mdi-alpha-p-box-outline</v-icon
              >
              <v-icon v-if="formRoles(item.groups).includes('tenantadmin')"
                >mdi-alpha-t-box-outline</v-icon
              >
              <v-icon v-if="formRoles(item.groups).includes('orgaadmin')"
                >mdi-alpha-o-box-outline</v-icon
              >
            </template>
            <template v-slot:top>
              <ManageUser
                v-bind:processType="processType"
                v-bind:item="selectedItem"
                @child-object="checkChildObject"
                v-if="showManagementDialog"
              />
            </template>
            <template v-slot:[`item.actions`]="{ item }">
              <v-tooltip top>
                <template v-slot:activator="{ on, attrs }">
                  <v-icon
                    v-bind="attrs"
                    v-on="on"
                    class="mr-2"
                    @click="
                      resetNotification();
                      processType = 'edit';
                      selectedItem = item;
                      showManagementDialog = true;
                    "
                    >mdi-pencil</v-icon
                  >
                </template>
                <span>Edit User</span></v-tooltip
              >
              <v-tooltip top>
                <template v-slot:activator="{ on, attrs }">
                  <v-icon
                    @click="
                      resetNotification();
                      processType = 'delete';
                      selectedItem = item;
                      showManagementDialog = true;
                    "
                    v-bind="attrs"
                    v-on="on"
                    >mdi-delete</v-icon
                  > </template
                ><span> Delete User</span></v-tooltip
              >
            </template>
          </v-data-table>
          <v-divider></v-divider>
        </v-card>
        <div class="d-flex justify-end">
          <v-btn
            id="buttons"
            class="my-5 mr-3"
            elevation="2"
            @click="
              resetNotification();
              processType = 'add';
              showManagementDialog = true;
            "
            >New User</v-btn
          >
        </div>
        <UIAlert
          class="mt-4"
          v-if="
            hasRequestError ||
              isEditSuccessful ||
              isDeleteSuccessful ||
              isAddSuccessful
          "
          v-bind:isSuccessful="!hasRequestError"
          v-bind:message="
            isEditSuccessful
              ? 'User updated successfully'
              : isDeleteSuccessful
              ? 'User deleted successfully'
              : isAddSuccessful
              ? 'User Added successfully'
              : $store.state.application.httpErrorMessage
          "
        />
      </v-col>
    </v-row>
  </v-container>
</template>
<style lang="scss" scoped>
::v-deep #buttons .v-btn__content {
  text-transform: none;
}
</style>
<script setup lang="ts">
/*
 * This file is Free Software under GNU Affero General Public License v >= 3.0
 * without warranty, see README.md and license for details.
 *
 * SPDX-License-Identifier: AGPL-3.0-or-later
 *
 * SPDX-FileCopyrightText: 2020 nic.at GmbH <https://nic.at>
 * Software-Engineering: 2020 Intevation GmbH <https://intevation.de>
 *
 * Author(s):
 * Fadi Abbud <fadi.abbud@intevation.de>
 */
import { useNotification } from "@/lib/use-notification";
import { useOrganisation } from "@/lib/use-organisation";
import { useUserInfo } from "@/lib/use-userinfo";
import {defineAsyncComponent, ref, onMounted, watch, computed, set} from "vue";
import { useStore } from "@/store";
import debounce from "debounce";

const SectionTitle = defineAsyncComponent(() =>
  import("@/components/ui/SectionTitle.vue")
);
const NodeInfo = defineAsyncComponent(() =>
  import("@/components/ui/NodeInfo.vue")
);
const ManageUser = defineAsyncComponent(() =>
  import("@/components/usermanagement/ManageUser.vue")
);
const UIAlert = defineAsyncComponent(() =>
  import("@/components/ui/UIAlert.vue")
);
const Pagination = defineAsyncComponent(() =>
  import("@/components/ui/Pagination.vue")
);
const store = useStore();
const users = computed(() => {
  return store.state.user.users;
});
const totalUser = ref(0);
const { formNodes, formRoles } = useUserInfo();
const loading = ref(false);
const hasHttpError = ref(false);
const getUsers = () => {
  store.commit("application/setHttpErrorMessage", "");
  loading.value = true;

  const requestOptions = options.value;
  requestOptions['filters'] = getFilters();

  store
    .dispatch("user/loadUsers", requestOptions)
    .then(response => {
      totalUser.value = response.data.meta.total;
    })
    .catch(() => {
      hasHttpError.value = true;
    })
    .finally(() => {
      loading.value = false;
    });
};

onMounted(() => {
  getUsers();
});

const {
  isAddSuccessful,
  isEditSuccessful,
  isDeleteSuccessful,
  hasRequestError,
  resetNotification
} = useNotification();
const showManagementDialog = ref(false);
const selectedItem = ref();
// React to the emitted values
const checkChildObject = e => {
  if (e.closeDialog) {
    showManagementDialog.value = false;
  }
  if (e.userChanged) {
    getUsers();
    switch (processType.value) {
      case "delete": {
        isDeleteSuccessful.value = true;
        break;
      }
      case "edit": {
        isEditSuccessful.value = true;
        break;
      }
      case "add": {
        isAddSuccessful.value = true;
        break;
      }
    }
  }
};
watch(
  () => store.state.user.selectedNode,
  () => {
    getUsers();
    resetNotification();
  }
);
const processType = ref("");
const options = ref({ page: 1, row: 10, filters: [] });
const search = ref("");
const checkPaginationObject = e => {
  if (e.refresh) {
    options.value = e.options;
    getUsers();
    search.value = e.options.search || "";
  }
};
const sortDirection = ref();

const {
  organisations,
  isOrgLoading,
  getOrganisations
} = useOrganisation();
const searchForOrga = ref("");
const selectedOrga = ref();

watch(
    () => searchForOrga.value,
    (newValue, oldValue) => {
      if (oldValue !== newValue) {
        triggerOrgaSearch(newValue);
      }
    }
);

const triggerOrgaSearch = debounce(() => {
  getOrganisations(1, undefined, searchForOrga.value);
}, 500);

const getFilters = () => {
  const filters = [];

  if (selectedOrga.value) {
    filters.push({key: 'ancestor', value: selectedOrga.value.organisation_id});
  }

  if (selectedTenant.value) {
    filters.push({key: 'tenant', value: selectedTenant.value.tenant_id});
  }

  return filters;
}

const selectedTenant = ref();
</script>
